<?php
/**
* echoPHP http://www.echophp.com
* Copyright 2013
*/
define('ECHOPHP_HELPER_VERSION', '1.0.3');
define('ECHOPHP_HELPER_VERSIONCHECK_PREFIX', 'helper');
$alone = (basename($_SERVER['PHP_SELF']) == basename(__FILE__));


// PHP4 doesn't have this function, we have to create one like PHP5.
if(!function_exists('http_build_query'))
{
	function http_build_query($formdata, $prefix = '', $arg_separator = NULL, $first = true)
	{
		static $data = array();
		static $size = false;
		static $count = 0;
		if(is_object($formdata))
		{
			$formdata = unserialize(serialize($formdata));
		}
		if($size == false) $size = count($formdata);
		foreach($formdata as $key => $value)
		{
			$key = urlencode($key);
			if(is_object($value))
			{
				$value = unserialize(serialize($value));
			}
			if($first) $count++;
			if(is_array($value))
			{
				http_build_query($value, (($first && !is_numeric($key)) ? '' : $prefix) . $key . ($first ? '' : '%5D' /* ] */) . '%5B' /* [ */, $arg_separator, false);
			}
			else
			{
				$data[] = (($first && !is_numeric($key)) ? '' : $prefix) . $key . ($first ? '' : '%5D' /* ] */) . '=' . urlencode($value);
			}
		}

		if($count == $size && $first)
		{
			if(!$arg_separator)
			{
				$arg_separator = @ini_get('arg_separator.output');
				if($arg_separator) $arg_separator = '&';
			}
			return ($data) ? implode($arg_separator, $data) : '';
		}
	}
}


if(!function_exists('mf_realpath'))
{
	function mf_realpath($cwd, $cd)
	{
		$cwd = trim($cwd, '/');
		$cwd_dirs = ($cd && $cd{0} == '/') ? array() : (($cwd && $cwd != '/') ? explode('/', $cwd) : array());
		$cd_dirs = ($cd ? explode('/', $cd) : array());
		$last_dir = array_pop($cwd_dirs);
		if($last_dir && strpos($last_dir, '.') === false)
		{
			$cwd_dirs[] = $last_dir;
		}
		$cd_len = count($cd_dirs);
		$i = 0;
		foreach($cd_dirs as $cd_dir)
		{
			$i++;
			if($cd_dir == '.' || $cd_dir == '')
			{
				continue;
			}
			else if($cd_dir == '..')
			{
				array_pop($cwd_dirs);
			}
			else
			{
				$cwd_dirs[] = (strpos($cd_dir, '.') !== false && $i == $cd_len) ? $cd_dir : rawurlencode(rawurldecode($cd_dir));
			}
		}

		return '/' . implode('/', $cwd_dirs);
	}
}


// This function is used to retreive data from a specified URL, using GET or POST.
// Supports URL Redirect
if(!function_exists('mf_request_url'))
{

function mf_request_url($url, $method = 'GET', $data = false, $first = true)
{
	$method = strtoupper($method);
	if($method != 'GET' && $method != 'POST') die('Invalid $method (second argument)!!! Only support GET and POST.');

	static $redirect = 0;
	static $rdata = '';
	if(!$first) $redirect++;
	if($redirect == 20) return false;

	if(!$url) return false;
	$com = @parse_url($url);
	if(!$com) return false;
	$http_scheme = (isset($com['scheme'])) ? $com['scheme'] : 'http';
	$http_host = $com['host'];
	$http_port = (isset($com['port']) && $com['port']) ? $com['port'] : 80;
	$http_path = (isset($com['path'])) ? $com['path'] : '/';

	$fp = @fsockopen($http_host, $http_port, $errno, $errstr, 10); // was 5
	if(!$fp) return false;
	else {
		$querystring = ($data ? (is_array($data) ? http_build_query($data) : $data) : '');
		$useragent = (isset($_SERVER['HTTP_USER_AGENT']) ? $_SERVER['HTTP_USER_AGENT'] : ECHOPHPMU_USER_AGENT);

		
		$method = 'GET';
		$com['query'] = $querystring;

		$getquerystring = (isset($com['query']) ? $com['query'] : '');
		if ($method == 'GET')
		{
			if ($querystring)
			{
				$getquerystring = ($getquerystring ? ($getquerystring . '&') : '') . $querystring;
			}
			else
			{
				$getquerystring = $querystring;
			}

			$querystring = '';
		}

		$request = $method . ' ' . $http_path . ($getquerystring ? ('?' . $getquerystring) : '') . " HTTP/1.1\r\n";
		$request .= "Host: {$http_host}\r\n";
		$request .= "User-Agent: {$useragent}\r\n";
		$request .= "Accept: */*\r\n";
		$request .= "Accept-Language: en-us,en;q=0.5\r\n";
		if ($method == 'POST')
		{
			$request .= "Content-Type: application/x-www-form-urlencoded\r\n";
			$request .= 'Content-Length: ' . @strlen($querystring) . "\r\n";
		}
		$request .= "Connection: close\r\n";
		$request .= "\r\n";
		$request .= $querystring;


		$data = '';
		if (@function_exists('stream_set_timeout')) { stream_set_timeout($fp, 20); }
		@fputs($fp, $request);

		if (@function_exists('socket_get_status')) { $status = @socket_get_status($fp); }
		else { $status = true; }

		while (!@feof($fp) && $status) {
			$data .= @fread($fp, 1024);
			if (@function_exists('socket_get_status')) { $status = @socket_get_status($fp); }
			else {
				if (@feof($fp) == true) { $status = false; }
				else { $status = true; }
			}
		}
		@fclose ($fp);

		//die("<textarea rows='30' cols='200' wordwrap='off'>{$request}\n\n==============================\n\n{$data}</textarea>");
		if (!$data) { return false; }
		$data = @explode("\r\n\r\n", $data, 2);
		if(!$data[0]) { return false; }

		$matches = array();
		if(!preg_match('/HTTP\/\d+\.?\d*\s+(\d+)\s+/i', $data[0], $matches)) { return false; }
		if(!isset($matches[1]) || !is_numeric($matches[1])) { return false; }
		$rstatus = trim($matches[1]);
		if($rstatus == '200') { $rdata = $data[1]; }
		if($rstatus == '301' || $rstatus == '302')
		{
			//die('here');
			$matches = array();
			if(!preg_match('/Location\:\s+(.+)\n+/i', $data[0], $matches)) { return false; }
			//print_r($matches);exit;
			if(!isset($matches[1])) { return false; }
			$_url = trim($matches[1]);
			$_inx = strpos($_url, ':');
			if($_inx !== false && $_inx > 0)
			{
				$url = $_url;
			}
			else
			{
				$url = $http_scheme . '://' . $http_host . ($http_port != 80 ? (':' . $http_port) : '') . mf_realpath($com['path'], $_url);
			}

			if ($method == 'GET')
			{
				mf_request_url($url, 'GET', false, false);
			}
			else if($method == 'POST')
			{
				mf_request_url($url, $method, $querystring, false);
			}

		}

		if($first) return $rdata;
		return false;
	}
}

}


if(!function_exists('is_uptodate'))
{
	function is_uptodate($suffix, $version)
	{
		if($data = mf_request_url('http://www.echophp.com/versioncheck/phpbbmf_' . $suffix . '.txt', 'GET'))
		{
			return version_compare($version, $data, '=');
		}

		return false;
	}
}

function mf_get_phpinfo() {
	if(!function_exists('phpinfo')) return false;
	ob_start();
	phpinfo();
	$phpinfo = @ob_get_clean();

	$info = explode("\n", $phpinfo);
	if(!is_array($info)) $info = array();
	$phpinfo = '';
	foreach($info as $val)
	{
		$val = trim($val);
		if((strpos($val, '<tr><td class="e">') === false or strpos($val, '<tr><td class="e">_') !== false) and $val != '</pre></td></tr>') continue;
		$phpinfo .= "$val\n";
	}
	$phpinfo = str_replace(array('<pre>', '</pre>', '<tr><td class="e">', '</td></tr>', '</td><td class="v">', ' |'), array('', '', '', '', '|', '|'), $phpinfo);
	$phpinfo = trim(html_entity_decode(strip_tags($phpinfo)));

	$info = explode("\n", $phpinfo);
	if(!is_array($info)) return false;
	$phpinfo = array();
	foreach($info as $val)
	{
		$parts = explode('|', $val);
		if(!is_array($parts)) continue;
		$parts = array_map('trim', $parts);
		$phpinfo[$parts[0]] = $parts[1];
	}

	return $phpinfo;
}

function status($status, $var = '', $required = false)
{
	echo '' . '<span style="color:' . ($status === true ? 'green' : 'red') . '; font-weight:bold;">' . ($status === -1 ? 'Can not detect' : ($status === true ? 'Yes' : 'No')) . '</span>' . ($required ? required() : '');
	if($var)
	{
		global $$var;
		$$var = $status;
	}
}

function required()
{
	return ' <sup style="color:white;border:1px solid red;padding:0px;background-color:red;font-size:xx-small">required</sup>';
}

$uptodate = false;

if($alone) {
$uptodate = true; // is_uptodate(ECHOPHP_HELPER_VERSIONCHECK_PREFIX, ECHOPHP_HELPER_VERSION);

// Date in the past
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT");
// always modified
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
// HTTP/1.1
header("Cache-Control: no-store, no-cache, must-revalidate");
header("Cache-Control: post-check=0, pre-check=0", false);
// HTTP/1.0
header("Pragma: no-cache");

?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-2">
<title>echoPHP phpBB MultiForums Software - Server Configuration Detecter</title>
<!-- link href="./../mf_temp/mf_styles.css" rel="stylesheet" type="text/css" -->
<style type="text/css">
<!--

body {font-family: Verdana, Arial, Helvetica, sans-serif; color:#333333; font-size: 11px;margin: 0px}

td {font-family: Verdana, Arial, Helvetica, sans-serif; font-size: 11px;  color:#333333;}
td.row1	{ background-color: #DFF1FF; }
td.row2	{ background-color: #BFE3FF; }
td.row3	{ background-color: #f8f8f8; }
td.td_head {color: #FFFFFF; font-size: 11px; font-weight : bold; background-color: #006699; padding:3px}
td.td_head a, td.td_head a:active, td.td_head a:hover, td.td_head a:visited, td.td_head a:link {
	color:#FFFFFF;
}
th {color: #FFFFFF; font-size: 11px; font-weight : bold; background-color: #006699; height: 25px;	padding:3px}
.reg_tb{background:#FFFFFF; color:#333333; border:1px solid #0791FE;}

a, a:visited, a:active {color:#0791FE; text-decoration:none}
a:hover {text-decoration:underline}

div.ajax, span.ajax{color:#0791FE; text-decoration:none; cursor:hand; cursor:pointer}
div.ajax:hover, span.ajax:hover{font-weight:bold; cursor:hand; cursor:pointer}

.error_message {
	color: #FF0000;
	font-size: 11px;
}

.topnav {color:#FFFFFF;}
a.topnav, a.topnav:visited, a.topnav:active {color:#FFFFFF; text-decoration:none;}
a.topnav:hover{color:#FFFFFF; text-decoration:underline}

.bottomnav {background:#FFFFFF; padding:3px; border:1px solid #CCCCCC}

.editable{
	color: #000;
	background-color: #ffffd3;
 }

.bold_green {
	font-weight: bold;
	color: green;
}

.paging_info { background-color: #F0F8FF; }
.paging_next { background-color: #BFE3FF; padding: 0px 5px 0px; }
.paging_current { background-color:#006699; color:#FFFFFF; padding: 0px 5px 0px; }

.style1 {
	color: #FF0000;
	font-weight: bold;
}
.style2 {color: #FF0000}
-->
</style>
</head>
<body>
<table width="770" border="0" align="center" cellpadding="0" cellspacing="0">
  <tr>
    <td height="400" valign="top"><div id="mf_content" style="padding: 10px 10px 0px">
		<form method="post" action="?tid=<?php echo base_convert(time() * rand(1, 9), 10, 16); ?>">
		<h2 align="center">Server Configuration Detecter</h2>
		<!--p>This script is used to detect server configuration to install <strong>echoPHP MF 3.0.x</strong>. If you would like check your server configuration for another version of echoPHP MF, please download another script at <a href="http://www.echophp.com" target="_blank">http://www.echophp.com</a></p-->
		<!--p><strong>Warning:</strong> Godaddy shared hosting packages are not affordable to run echoPHP MF v2 and v3.</p-->
		<!--p>If you was downloaded this script for a long time, please use the newest script from http://www.echophp.com/mf_helper.zip</p-->
<?php
} else {
	$uptodate = true;
}


if($uptodate)
{
	$info = mf_get_phpinfo();
	//print_r($info);exit;
	//print_r($_SERVER);exit;
	$cancontinue = false;
	if(!isset($_POST['dbhost']))
	{
		$dbhost = 'localhost';
	}
	else
	{
		$dbhost = $_POST['dbhost'];
	}
	$others = array('dbuser', 'dbpass');
	foreach($others as $other)
	{
		if(isset($_POST[$other]))
		{
			$$other = $_POST[$other];
		}
		else
		{
			$$other = '';
		}
	}

	$apache = false;
	$mod_rewrite = false;
	$apache_version = $_SERVER['SERVER_SOFTWARE'];
	if(function_exists('apache_get_version'))
	{
		$apache = true;
		$apache_version = apache_get_version();
		if(function_exists('apache_get_modules'))
		{
			$mod_rewrite = in_array('mod_rewrite', apache_get_modules());
		}
		else
		{
			$mod_rewrite = -1;
		}
	}
	else if(strpos(strtolower($apache_version), 'apache') !== false)
	{
		$apache = true;
		$mod_rewrite = -1;
	}

	if($mod_rewrite === -1 and strpos(strtolower($apache_version), ' mod_rewrite/') !== false)
	{
		$mod_rewrite = true;
	}

	if($mod_rewrite === -1 and $info and isset($info['Loaded Modules']))
	{
		$mods = @explode(' ', $info['Loaded Modules']);
		if(!$mods) $mods = array();
		$mods = array_map('trim', $mods);
		$mods = array_map('strtolower', $mods);
		$mod_rewrite = in_array('mod_rewrite', $mods);
	}

?>
          <table width="100%" cellpadding="2" cellspacing="1" border="0">
            <tr>
              <th colspan="2">Detected Server Configuration</th>
            </tr>
            <tr>
              <td class="row2" align="right" valign="top" nowrap="nowrap">Operating System:</td>
              <td class="row2"><?php if($info and isset($info['System'])) {echo $info['System'];} else {echo PHP_OS;} ?></td>
            </tr>
            <tr>
              <td class="row2" align="right" valign="top" nowrap="nowrap">Web Server:</td>
              <td class="row2"><?php echo $apache_version; ?></td>
            </tr>
            <tr>
              <td class="row2" align="right" valign="top" nowrap="nowrap">PHP Version:</td>
              <td class="row2"><?php if(phpversion() < '4.3.3') {echo '<span style="color:red">';} echo phpversion(); if(phpversion() < '4.3.3') {echo ' - Please upgrade your PHP Engine to 4.3.3 or higher.</span>'; $php = false;} else {$php = true;}?></td>
            </tr>
            <tr>
              <td class="row2" align="right" valign="top" nowrap="nowrap">Apache Modules:</td>
              <td class="row2">mod_rewrite <?php status($mod_rewrite); ?></td>
            </tr>
            <tr>
              <td class="row2" align="right" valign="top" nowrap="nowrap">PHP Libraries:</td>
              <td class="row2">
																MySQL library <?php status(function_exists('mysql_connect'), 'mysql', true); ?><br />
								PCRE (Perl Compatible Regular Expressions) Support <?php status(function_exists('preg_match'), 'pcre', true); ?><br />
								zlib Compression Support <?php status(function_exists('gzopen'), 'zlib', true); ?><br />
                XML Support <?php status(function_exists('xml_parser_create'), 'xml', true); ?><br />
								GD Support <?php status(function_exists('imagecreate'), 'gd'); ?><br />
								Remote FTP Support <?php status(function_exists('ftp_connect'), 'ftp'); ?><br />
								<?php /* ?>
								iconv support <?php status(function_exists('iconv'), 'iconv'); ?><br />
								Multibyte Support (mbstring) <?php status(function_exists('mb_convert_encoding'), 'mbstring'); ?><br />
								<?php */ ?>
								Dynamic Library Support <?php status(function_exists('dl'), 'dl'); ?><br />
							</td>
            </tr>
						<!--
            <tr>
              <td class="row2" align="right" valign="top" nowrap="nowrap">MySQL version:</td>
              <td class="row2">
								<?php
								if(!isset($_POST['dbhost']))
								{
								?>
								<?php
								}
								?>
								<table cellpadding="2" cellspacing="2" border="0">
									<tr>
										<td valign="top">MySQL Host:</td>
										<td><input type="text" name="dbhost" value="<?php echo $dbhost; ?>" size="20" maxlength="100" /></td>
									</tr>
									<tr>
										<td valign="top">MySQL User:</td>
										<td><input type="text" name="dbuser" value="<?php echo $dbuser; ?>" size="20" maxlength="100" /></td>
									</tr>
									<tr>
										<td valign="top">MySQL Password:</td>
										<td><input type="password" name="dbpass" value="<?php echo $dbpass; ?>" size="20" maxlength="100" /></td>
									</tr>
									<tr>
										<td valign="top">&nbsp;</td>
										<td><input type="submit" name="submit" value="Detect" /><input type="reset" name="reset" value="Reset" /></td>
									</tr>
								</table>

								Does not check, it should be equal or greater than 4.1.0 or higher. <?php echo required(); ?>
							</td>
            </tr>
						-->
						<tr>
							<td class="row2" align="right" valign="top">Other Requirements:<br /><em><b>(Please check it yourself)</b></em></td>
							<td class="row2">
								Ability to park/point domains if you would like to use multiple add-on domains.<br />
								Ability to edit (or have edited) web server config to make wildcard entry for your domain. <?php echo required(); ?><br />
								Ability to edit (or have edited) DNS entry to make wildcard DNS entry for your domain. <?php echo required(); ?><br />
							</td>
						</tr>
            <tr>
              <th colspan="2">MySQL Information</th>
            </tr>
						<?php
						//$mysql = false;
						$link = false;
						$affordable_mysql = false;
						$mysql_utf8 = false;
						$mysql_myisam = false;
						if($mysql) {
						?>
						<?php
						$mysql_error = '';
						if(isset($_POST['dbhost'])) {
							$link = @mysql_connect($dbhost, $dbuser, $dbpass);
							if(!$link) {
								$mysql_error = mysql_error();
							}
						} else {
							$mysql_error = 'Please enter MySQL info: host, username, password.';
						}

						if(!$link) {
						?>
						<tr>
							<td class="row1" align="center" nowrap="nowrap" colspan="2">
								To continue, please provide your MySQL information: host, username, password.
							</td>
						</tr>
						<?php
						}

						if($mysql_error) {
						?>
						<tr>
							<td class="row2" align="right" valign="top" nowrap="nowrap">Error Message:</td>
							<td class="row2 style1"><?php echo $mysql_error; ?></td>
						</tr>
						<?php
						} else {
						?>
						<tr>
							<td class="row2" align="right" valign="top" nowrap="nowrap">MySQL Info:</td>
							<td class="row2">
								MySQL Library version: <span class="bold_green"><?php echo mysql_get_client_info(); ?></span><br />
								MySQL Host info: <span class="bold_green"><?php echo mysql_get_host_info($link); ?></span><br />
								MySQL Protocol: <span class="bold_green"><?php echo mysql_get_proto_info($link); ?></span><br />
								MySQL Server version:
								<?php
								$server_info = mysql_get_server_info($link);
								//$server_info = '4.0.19-standard';
								$affordable_mysql = version_compare($server_info, '4.1.2', '>=');
								if($affordable_mysql) {
								?>
									<span class="bold_green">
								<?php
								} else {
								?>
									<span class="style1">
								<?php
								}
								echo $server_info;
								?>
								</span><br />
								UTF-8 Support:
								<?php
								$variables = array();
								mysql_query('SET NAMES utf8');
								$result = mysql_query('SHOW VARIABLES LIKE "character%"');
								//$result = mysql_query('SHOW VARIABLES');
								while($myrow = mysql_fetch_row($result)) {
									$variables[$myrow[0]] = $myrow[1];
								}
								//print_r($variables);exit;
								$variables = array_map('strtolower', $variables);
								$mysql_utf8 = (
									$variables['character_set_client'] == 'utf8' and
									$variables['character_set_connection'] == 'utf8' and
									$variables['character_set_results'] == 'utf8'
								);
								if($mysql_utf8) {
								?>
									<span class="bold_green">
								<?php
								} else {
								?>
									<span class="style1">
								<?php
								}
								echo ($mysql_utf8 ? 'Yes' : 'No');
								?>
								</span><br />
								MyISAM Storage Engine Support:
								<?php
								$variables = array();
								$result = mysql_query('SHOW STORAGE ENGINES');
								while($myrow = mysql_fetch_row($result)) {
									$variables[$myrow[0]] = $myrow[1];
								}
								$variables = array_map('strtolower', $variables);
								$variables = array_change_key_case($variables, CASE_LOWER);
								$mysql_myisam = (
									$variables['myisam'] == 'default' or
									$variables['myisam'] == 'yes'
								);
								if($mysql_myisam) {
								?>
									<span class="bold_green">
								<?php
								} else {
								?>
									<span class="style1">
								<?php
								}
								echo ($mysql_myisam ? 'Yes' : 'No');
								?>
								</span><br />
							</td>
						</tr>
						<?php
						}
						?>
						<?php
						if(!$link) {
						?>
						<tr>
							<td class="row2" align="right" nowrap="nowrap">MySQL Host:</td>
							<td class="row2"><input type="text" name="dbhost" value="<?php echo $dbhost; ?>" size="20" maxlength="100" /></td>
						</tr>
						<tr>
							<td class="row2" align="right" nowrap="nowrap">MySQL User:</td>
							<td class="row2"><input type="text" name="dbuser" value="<?php echo $dbuser; ?>" size="20" maxlength="100" /></td>
						</tr>
						<tr>
							<td class="row2" align="right" nowrap="nowrap">MySQL Password:</td>
							<td class="row2"><input type="password" name="dbpass" value="<?php echo $dbpass; ?>" size="20" maxlength="100" /></td>
						</tr>
						<tr>
							<td class="row2" align="right" valign="top" nowrap="nowrap">&nbsp;</td>
							<td class="row2">
								<input type="submit" name="submit" value="Continue" /><input type="reset" name="reset" value="Reset" />
							</td>
						</tr>
						<?php
						}
						} else {
						?>
						<tr>
							<td class="row1" align="center" colspan="2">
								Your server doesn't support MySQL library. To continue to detect your server configuration, please install MySQL library for PHP.
								For more information about MySQL, please refer to <a href="http://www.php.net/manual/en/intro.mysql.php" target="_blank">http://www.php.net/manual/en/intro.mysql.php</a>.
							</td>
						</tr>
						<?php
						}

						if(isset($_POST['dbhost']) and $link) {
						?>
            <tr>
              <th colspan="2">Checking Result</th>
            </tr>
						<?php
						//$apache = false;
						//$dl = false;
						//$mysql_utf8 = false;
						//$mysql_myisam = false;
						if($php) {
							$cancontinue = ($apache and $mysql and $affordable_mysql and $mysql_utf8 and $mysql_myisam and $zlib and $pcre and $xml);
							if($cancontinue) {
								?>
						<tr>
							<td class="row2" valign="top" align="right">Message:</td>
							<td class="row2" style="color:green; font-weight:bold">

                <?php if (defined('_ITSME_')) { ?>
                Your server are able to run the software, press &quot;Start&quot; to continue.
                <?php } else { ?>
                You can install echoPHP phpBB MultiForums Software.
                Please get it <a href="http://www.echophp.com/clients/client_area.php" target="_blank">here</a>.<div style="font-weight:normal;color:black">
                <?php } ?>
                <br />
								<?php /*if(!$apache) echo '&raquo; If you want to use <strong>"URL Rewrite" for Search Engine Optimization</strong>, you should use <a href="http://httpd.apache.org/" target="_blank">Apache 1.3 or higher</a> with <a href="http://httpd.apache.org/docs/1.3/mod/mod_rewrite.html" target="_blank">mod_rewrite</a> enabled.<br />';*/ ?>
								<?php if($apache and $mod_rewrite === false) echo '&raquo; If you want to use <strong>"URL Rewrite" for Search Engine Optimization</strong>, you should enable <a href="http://httpd.apache.org/docs/1.3/mod/mod_rewrite.html" target="_blank">mod_rewrite</a> for Apache.<br />'; ?>
								<?php if($apache and $mod_rewrite === -1) echo '&raquo; Can not deletect <a href="http://httpd.apache.org/docs/1.3/mod/mod_rewrite.html" target="_blank">mod_rewrite</a> module, please check it yourself. If it is installed, skip this message.<br />'; ?>
								<?php if(!$gd) echo '&raquo; If you want to use image verification, you should install <a href="http://www.php.net/manual/en/intro.image.php" target="_blank">GD</a>.<br />'; ?>
								<?php /* if(!$iconv and !$mbstring) echo '&raquo; If you want to use the software for non-English language, such as: Chinese, Arabic, etc... you should install <a href="http://www.php.net/manual/en/intro.iconv.php" target="_blank">iconv</a> or <a href="http://www.php.net/manual/en/intro.mbstring.php" target="_blank">Multibyte String</a> (mbstring).<br />'; */ ?>
								</div>
							</td>
						</tr>
								<?php
							} else {
								?>
						<tr>
							<td class="row2" valign="top" align="right">Message:</td>
							<td class="row2" style="color:red; font-weight:bold">
								You can not install echoPHP phpBB MultiForums Software.<div style="font-weight:normal;color:black">
								Please correct following requirements or install required softwares/modules:<br />
								<?php if(!$apache) echo '&raquo; Install <a href="http://httpd.apache.org/" target="_blank">Apache</a> 1.3 or higher</a> as your web server.<br />'; ?>
								<?php if(!$mysql) echo '&raquo; Install and enable <a href="http://www.php.net/manual/en/intro.mysql.php" target="_blank">MySQL</a> library for PHP.<br />'; ?>
								<?php if($mysql and !$affordable_mysql) echo '&raquo; MySQL server version is too old. Please upgrade MySQL server to <a href="http://www.mysql.com/products/" target="_blank">4.1.0 or higher</a>.<br />'; ?>
								<?php if($mysql and !$mysql_utf8) echo '&raquo; MySQL server does not support UTF-8. Please refer to <a href="http://dev.mysql.com/doc/refman/4.1/en/charset.html" target="_blank">MySQL Character Set Support</a> for more infomation.<br />'; ?>
								<?php if($mysql and !$mysql_myisam) echo '&raquo; MySQL server does not support MyISAM Storage Engine. Please refer to <a href="http://dev.mysql.com/doc/refman/4.1/en/myisam-storage-engine.html" target="_blank">The MyISAM Storage Engine</a> for more infomation.<br />'; ?>
								<?php if(!$pcre) echo '&raquo; Install and enable <a href="http://www.php.net/manual/en/intro.pcre.php" target="_blank">PCRE</a> for PHP.<br />'; ?>
								<?php if(!$zlib) echo '&raquo; Install and enable <a href="http://www.php.net/manual/en/intro.zlib.php" target="_blank">zlib</a> for PHP.<br />'; ?>
								<?php if(!$xml) echo '&raquo; Enable <a href="http://www.php.net/manual/en/intro.xml.php" target="_blank">XML</a> for PHP.<br />'; ?>
								</div>
							</td>
						</tr>
								<?php
							}
						} else {
						?>
						<tr>
							<td class="row2" valign="top" align="right">Message:</td>
							<td class="row2" style="color:red; font-weight:bold">
								Your PHP Engine is too old, please upgrade it to 4.3.3 or higher first.
							</td>
						</tr>
						<?php
						} // End of $php

						} // End of $link
						?>
          </table>
<br />
<?php
	if(!$cancontinue) {
?>
				<input type="hidden" name="do" value="home" />
				<input type="hidden" name="step" value="" />
<?php
	}
} else {
?>
				<p>&nbsp;</p>
				<p>&nbsp;</p>
				<p>&nbsp;</p>
				<p>&nbsp;</p>
				<h4 style="color:red; text-align:center">This script is outdate, <a href="http://www.echophp.com/mf_helper.zip">click here</a> to download newest version.</h4>
				<p>&nbsp;</p>
				<p>&nbsp;</p>
				<p>&nbsp;</p>
				<p>&nbsp;</p>
<?php
}

if($alone) {

?>

				</form>
      </div></td>
  </tr>
</table>
<br />
<table width="770" border="0" align="center" cellpadding="3" cellspacing="0">
	<tr>
		<td colspan="2">
			<strong>Disclaimer:</strong> This script only try to detect your server configurations. It doesn't install, modify, change, delete, add, .... anything on/to your system. Please don't assume that issues on your system caused by this script.
			<p>&nbsp;</p>
		</td>
	</tr>
	<tr>
		<td></td>
		<td align="right">Powered by <a href="http://www.echophp.com" target="_blank">echoPHP phpBB MultiForums Software</a></td>
	</tr>
</table>
</body>
</html>
<?php
}
?>